#(C) Copyright International Business Machines  Corp., 2011-2012
%define sles %(test -e /etc/SuSE-release && echo 1 || echo 0)
%define rhel %(test -e /etc/redhat-release && echo 1 || echo 0)

Summary: IBM Tape SCSI Device Driver for Linux
Name: lin_tape
Version: 1.76.0
Release: 1
License: GPL
Vendor: IBM
Group: System Environment/Kernel
Source: %{name}-%{version}.tgz
# this is the build root suggested by redhat
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
AutoReqProv: no
%if %{sles}
BuildRequires: kernel-source 
%endif
%if %{rhel}
BuildRequires: kernel-devel rpm-build
%endif
BuildRequires: glibc-devel gcc libstdc++ make bzip2
Obsoletes: IBMtape
Conflicts: IBMtape lin_tape < %{version}
Packager: IBM Tape SCSI Device Driver Development

%undefine _enable_debug_packages

%define debug_package %{nil}

%define KERNEL %( echo ${KERNEL:-%(uname -r)})
%define KERNELTYPES default smp bigsmp hugemem
%define TOSTILE() %(echo %1|tr ' ' '|')
%define KERNELBASENAME %(echo %{KERNEL}|sed --regexp-extended -e 's/[^a-zA-Z0-9]*(%{TOSTILE %KERNELTYPES})*$//p;d')
#%define KERNELSPRESENT %(cd /lib/modules;echo %{KERNELBASENAME}*|sed -e '/%{KERNELBASENAME}[^a-zA-Z0-9]{,1}(%{TOSTILE %KERNELTYPES})/p')
%define KERNELSPRESENT %KERNEL
%define DISTRO %( cat /etc/redflag-release 2>/dev/null| cat - /etc/redhat-release 2>/dev/null| cat - /etc/SuSE-release 2>/dev/null| head -1 2>/dev/null)

%description 
%( echo "The IBM Tape Device Driver, lin_tape, product is a device driver that provides attachment for the IBM TotalStorage and System Storage tape devices to Linux compatible platforms."| tr '\n' ' ' | fold -s -w 65 )

%prep
%setup -q

%build
p=`echo $MACHTYPE|cut -f 1 -d '-'`
( [ $p == "i386" ] || [ $p == "i586" ] || [ $p == "i686" ] ) && proc="Intel"
( [ $p == "ppc64" ] || [ $p == "powerpc" ] || [ $p == "powerpc64" ]) && proc="pSeries"
( [ $p == "s390" ] ) && proc="zSeries"
( [ $p == "s390x" ] ) && proc="zSeries"
( [ $p == "ia64" ] ) && proc="Intel"
( [ $p == "x86_64" ] ) && proc="AMD"
cp -af lin_tape_359X_${proc}.ReadMe lin_tape_359X.ReadMe
cp -af lin_tape_Ultrium_${proc}.ReadMe lin_tape_Ultrium.ReadMe

make KERNEL=%{KERNEL} PROC=$p driver

%install
rm -rf $RPM_BUILD_ROOT
%( for f in %{KERNELSPRESENT}; do echo "install -D -m 644 bldtmp/lin_tape-$f.ko \$RPM_BUILD_ROOT/lib/modules/$f/kernel/drivers/scsi/lin_tape.ko"; done)

PROC=`uname -m`
p=$PROC
( [ $p == "i386" ] || [ $p == "i586" ] || [ $p == "i686" ] ) && PROC=i386

#[[ $PROC =~ i.86 ]] && PROC=i386  this requires a newer bash than suse ships

install -D -m 700 lin_tape $RPM_BUILD_ROOT/etc/init.d/lin_tape
cd $RPM_BUILD_ROOT
ln -sf /etc/init.d/lin_tape /usr/sbin/rclin_tape
cd -

%pre

# if not kernel %{KERNEL}, exit the install
KERNEL=`uname -r`
if [ `echo \`echo /lib/modules/*|tr ' ' '\n'|rev|cut -f 1 -d '/'|rev\` %{KERNELSPRESENT}|tr ' ' '\n'|sort|uniq -d|wc|cut -b 1-7` -eq 0 ] ; then
  cat <<EOF
 %( echo "The current install of lin_tape supports Kernel(s) %{KERNELSPRESENT} only. None of these kernels are present. Exiting the installation."|fold -s -w 65)
EOF
  exit 100
fi

# If this will be the 2nd (or more) copies of the driver on the system
# remove the system initialization code

if [[ "$1" > 1 ]]; then
  [ -x /etc/init.d/lin_tape ] && /etc/init.d/lin_tape stop
  chkconfig --del lin_tape >/dev/null
  rmmod lin_tape || true
fi  

%post
# software is on the system, now configure it and kick it off
depmod -aq
chkconfig --add lin_tape >/dev/null
/etc/init.d/lin_tape start
echo lin_tape loaded

%preun
#we need to check if this is a rpm -e or rpm -U command
if [[ "$1" == "0" ]]; then

  # 0 copies will be left after this -e or -U command therefore we
  # need to shut down the daemon and remove the initialization links
  [ -x /etc/init.d/lin_tape ] && /etc/init.d/lin_tape stop
  chkconfig --del lin_tape >/dev/null
  rmmod lin_tape >/dev/null || true

fi

%postun
depmod -aq

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc lin_tape_Ultrium.ReadMe lin_tape_359X.ReadMe COPYING COPYING.LIB
%( for f in %{KERNELSPRESENT}; do echo "/lib/modules/$f/kernel/drivers/scsi/lin_tape.ko"; done)
%attr(0755,root,root) /etc/init.d/lin_tape

%changelog
* Wed Jan 31 2007 IBM Corporation
- Redesign the build system to no longer require autoconf. It is significantly cleaner and versatile.  'rpmbuild -tb ...' works, as does 'make rpm', as does sticking the source directory into the kernel source, as does rpmbuild -bb (after doing an install of the source)
